	SAVE
	LISTING OFF
	
;For use with asl <http://john.ccac.rwth-aachen.de:8000/as/>.

;Device Constants
ICID = 0xAA1
IHRC_FREQ = 16000000 ;16 MHz
ILRC_FREQ = 55000 ;55 kHz
INT_VECT = 0x010
PROGEND = 0x7DF
RAMEND = 0x7F

;Factory Calibration address locations
FACTORY_IHRCR = 0x7ed
FACTORY_BGTR = 0x7ee
;TODO: something is stored at 0x7ff

;FUSE definitions
FUSE_WORD = 0x07ff
FUSE_BITS_HIGH = 0x30FC ; - - 1 1   B B 0 D   1 1 1 1   1 1 0 S
;     Blank IC = 0x3FFD ; - - 1 1   1 1 1 1   1 1 1 1   1 1 1 1
;                (Fast boot-up, Normal IO drive, Security off)
FUSE_BOOTUP_SLOW = (0<<10)
FUSE_BOOTUP_FAST = (3<<10)
FUSE_IO_DRV_LOW    = (0<<8)
FUSE_IO_DRV_NORMAL = (1<<8)
FUSE_SECURITY_ON  = (0<<0)
FUSE_SECURITY_OFF = (1<<0)

;Register address definitions
FLAG		SFR	0x00
			;0x01
SP		SFR	0x02
CLKMD		SFR	0x03
INTEN		SFR	0x04
INTRQ		SFR	0x05
T16M		SFR	0x06
			;0x07
MISC		SFR	0x08
TM2B		SFR	0x09
EOSCR		SFR	0x0a
IHRCR		SFR	0x0b ;undocumented
INTEGS		SFR	0x0c
PADIER		SFR	0x0d
PBDIER		SFR	0x0e
MISC2		SFR	0x0f ;undocumented
PA		SFR	0x10
PAC		SFR	0x11
PAPH		SFR	0x12
			;0x13
PB		SFR	0x14
PBC		SFR	0x15
PBPH		SFR	0x16
TM2S		SFR	0x17
GPCC		SFR	0x18
GPCS		SFR	0x19
BGTR		SFR	0x1a ;undocumented
MISCLVR		SFR	0x1b ;undocumented
TM2C		SFR	0x1c
TM2CT		SFR	0x1d
			;0x1e
			;0x1f
PWMG0C		SFR	0x20
PWMG0S		SFR	0x21
PWMG0DTH	SFR	0x22
PWMG0DTL	SFR	0x23
PWMG0CUBH	SFR	0x24
PWMG0CUBL	SFR	0x25
PWMG1C		SFR	0x26
PWMG1S		SFR	0x27
PWMG1DTH	SFR	0x28
PWMG1DTL	SFR	0x29
PWMG1CUBH	SFR	0x2a
PWMG1CUBL	SFR	0x2b
PWMG2C		SFR	0x2c
PWMG2S		SFR	0x2d
PWMG2DTH	SFR	0x2e
PWMG2DTL	SFR	0x2f
PWMG2CUBH	SFR	0x30
PWMG2CUBL	SFR	0x31
TM3C		SFR	0x32
TM3CT		SFR	0x33
TM3S		SFR	0x34
TM3B		SFR	0x35
			;0x36
			;0x37
			;0x38
ILRCR		SFR	0x39 ;undocumented
			;0x3a
			;...
			;0x3f

;FLAG register definitions
FLAG_OV BIT 3
FLAG_AC BIT 2
FLAG_C  BIT 1
FLAG_Z  BIT 0

;CLKMD register definitions
CLKMD_SYSCLK2   BIT 7
CLKMD_SYSCLK1   BIT 6
CLKMD_SYSCLK0   BIT 5
CLKMD_SYSCLK = CLKMD_SYSCLK0
CLKMD_IHRC_DIV4_gc  = (0<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV2_gc  = (1<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_EOSC_DIV4_gc  = (3<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_EOSC_DIV2_gc  = (4<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_EOSC_gc       = (5<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_ILRC_DIV4_gc  = (6<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_ILRC_gc       = (7<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV16_gc = (0<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV8_gc  = (1<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_ILRC_DIV16_gc = (2<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV32_gc = (3<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV64_gc = (4<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_EOSC_DIV8_gc  = (5<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_EN   BIT 4
CLKMD_CLOCKTYPE BIT 3
CLKMD_ILRC_EN   BIT 2
CLKMD_WDT_EN    BIT 1
CLKMD_PRSTB     BIT 0

;INTEN register definitions
INTEN_TM3   BIT 7
INTEN_TM2   BIT 6
INTEN_PWMG0 BIT 5
INTEN_COMP  BIT 4
INTEN_T16   BIT 2
INTEN_PB0   BIT 1
INTEN_PA0   BIT 0

;INTRQ register definitions
INTRQ_TM3   BIT 7
INTRQ_TM2   BIT 6
INTRQ_PWMG0 BIT 5
INTRQ_COMP  BIT 4
INTRQ_T16   BIT 2
INTRQ_PB0   BIT 1
INTRQ_PA0   BIT 0

;T16M register definitions
T16M_CLK_SRC2 BIT 7
T16M_CLK_SRC1 BIT 6
T16M_CLK_SRC0 BIT 5
T16M_CLK_SRC = T16M_CLK_SRC0
T16M_CLK_DISABLE_gc  = (0<<T16M_CLK_SRC)
T16M_CLK_SYSCLK_gc   = (1<<T16M_CLK_SRC)
T16M_CLK_PA4_FALL_gc = (3<<T16M_CLK_SRC)
T16M_CLK_IHRC_gc     = (4<<T16M_CLK_SRC)
T16M_CLK_EOSC_gc     = (5<<T16M_CLK_SRC)
T16M_CLK_ILRC_gc     = (6<<T16M_CLK_SRC)
T16M_CLK_PA0_FALL_gc = (7<<T16M_CLK_SRC)
T16M_CLK_DIV1 BIT 4
T16M_CLK_DIV0 BIT 3
T16M_CLK_DIV = T16M_CLK_DIV0
T16M_CLK_DIV1_gc  = (0<<T16M_CLK_DIV)
T16M_CLK_DIV4_gc  = (1<<T16M_CLK_DIV)
T16M_CLK_DIV16_gc = (2<<T16M_CLK_DIV)
T16M_CLK_DIV64_gc = (3<<T16M_CLK_DIV)
T16M_INT_SRC2 BIT 2
T16M_INT_SRC1 BIT 1
T16M_INT_SRC0 BIT 0
T16M_INT_SRC = T16M_INT_SRC0
T16M_INT_BIT8_gc  = (0<<T16M_INT_SRC)
T16M_INT_BIT9_gc  = (1<<T16M_INT_SRC)
T16M_INT_BIT10_gc = (2<<T16M_INT_SRC)
T16M_INT_BIT11_gc = (3<<T16M_INT_SRC)
T16M_INT_BIT12_gc = (4<<T16M_INT_SRC)
T16M_INT_BIT13_gc = (5<<T16M_INT_SRC)
T16M_INT_BIT14_gc = (6<<T16M_INT_SRC)
T16M_INT_BIT15_gc = (7<<T16M_INT_SRC)

;EOSCR register definitions
EOSCR_ENABLE          BIT 7
EOSCR_XTAL_SEL1       BIT 6
EOSCR_XTAL_SEL0       BIT 5
EOSCR_XTAL_SEL = EOSCR_XTAL_SEL0
EOSCR_32KHZ_gc = (1<<EOSCR_XTAL_SEL)
EOSCR_1MHZ_gc  = (2<<EOSCR_XTAL_SEL)
EOSCR_4MHZ_gc  = (3<<EOSCR_XTAL_SEL)
EOSCR_BG_LVR_SHUTDOWN BIT 0

;INTEGS register definitions
INTEGS_T16 BIT 4
INTEGS_T16_RISING_gc  = (0<<INTEGS_T16)
INTEGS_T16_FALLING_gc = (1<<INTEGS_T16)
INTEGS_PB0 BIT 2
INTEGS_PB0_BOTH_gc    = (0<<INTEGS_PB0)
INTEGS_PB0_RISING_gc  = (1<<INTEGS_PB0)
INTEGS_PB0_FALLING_gc = (2<<INTEGS_PB0)
INTEGS_PA0 BIT 0
INTEGS_PA0_BOTH_gc    = (0<<INTEGS_PA0)
INTEGS_PA0_RISING_gc  = (1<<INTEGS_PA0)
INTEGS_PA0_FALLING_gc = (2<<INTEGS_PA0)

;MISC register definitions
MISC_WAKEUP      BIT 5
MISC_WAKEUP_NORMAL_gc = (0<<MISC_WAKEUP)
MISC_WAKEUP_FAST_gc   = (1<<MISC_WAKEUP)
MISC_LCD_BIAS    BIT 4
MISC_LVR_DISABLE BIT 2
MISC_WDT1        BIT 1
MISC_WDT0        BIT 0
MISC_WDT = MISC_WDT0
MISC_WDT_8K_gc   = (0<<MISC_WDT)
MISC_WDT_16K_gc  = (1<<MISC_WDT)
MISC_WDT_64K_gc  = (2<<MISC_WDT)
MISC_WDT_256K_gc = (3<<MISC_WDT)

;MISC2 register definitions (TODO: not in datasheet!)
MISC2_COMP_EDGE_INT1 BIT 6
MISC2_COMP_EDGE_INT0 BIT 5
MISC2_COMP_EDGE_INT = MISC2_COMP_EDGE_INT0
MISC2_COMP_EDGE_INT_BOTH_gc = (0<<MISC2_COMP_EDGE_INT)
MISC2_COMP_EDGE_INT_RISE_gc = (1<<MISC2_COMP_EDGE_INT)
MISC2_COMP_EDGE_INT_FALL_gc = (2<<MISC2_COMP_EDGE_INT)
MISC2_TM3_PWMG20     BIT 4
MISC2_COMP_PWMG10    BIT 3

;MISCLVR register definitions (not in datasheet!)
MISCLVR_LVR2    BIT 7
MISCLVR_LVR1    BIT 6
MISCLVR_LVR0    BIT 5
MISCLVR_LVR = MISCLVR_LVR0
MISCLVR_4V_gc   = (0x0<<MISCLVR_LVR)
MISCLVR_3V5_gc  = (0x1<<MISCLVR_LVR)
MISCLVR_3V_gc   = (0x2<<MISCLVR_LVR)
MISCLVR_2V75_gc = (0x3<<MISCLVR_LVR)
MISCLVR_2V5_gc  = (0x4<<MISCLVR_LVR)
MISCLVR_1V8_gc  = (0x5<<MISCLVR_LVR)
MISCLVR_2V2_gc  = (0x6<<MISCLVR_LVR)
MISCLVR_2V_gc   = (0x7<<MISCLVR_LVR)
MISCLVR_BG_DIV1 BIT 1
MISCLVR_BG_DIV0 BIT 0
MISCLVR_BG_DIV = MISCLVR_BG_DIV0
MISCLVR_BG_ON_gc    = (0<<MISCLVR_BG_DIV)
MISCLVR_BG_DIV4_gc  = (1<<MISCLVR_BG_DIV)
MISCLVR_BG_DIV32_gc = (2<<MISCLVR_BG_DIV)
MISCLVR_BG_AUTO_gc  = (3<<MISCLVR_BG_DIV)

;TM2C register definitions
TM2C_CLK_SRC3 BIT 7
TM2C_CLK_SRC2 BIT 6
TM2C_CLK_SRC1 BIT 5
TM2C_CLK_SRC0 BIT 4
TM2C_CLK_SRC = TM2C_CLK_SRC0
TM2C_CLK_DISABLE_gc  = (0x0<<TM2C_CLK_SRC)
TM2C_CLK_SYSCLK_gc   = (0x1<<TM2C_CLK_SRC)
TM2C_CLK_IHRC_gc     = (0x2<<TM2C_CLK_SRC)
TM2C_CLK_EOSC_gc     = (0x3<<TM2C_CLK_SRC)
TM2C_CLK_ILRC_gc     = (0x4<<TM2C_CLK_SRC)
TM2C_CLK_COMP_gc     = (0x5<<TM2C_CLK_SRC)
TM2C_CLK_PA0_RISE_gc = (0x8<<TM2C_CLK_SRC)
TM2C_CLK_PA0_FALL_gc = (0x9<<TM2C_CLK_SRC)
TM2C_CLK_PB0_RISE_gc = (0xA<<TM2C_CLK_SRC)
TM2C_CLK_PB0_FALL_gc = (0xB<<TM2C_CLK_SRC)
TM2C_CLK_PA4_RISE_gc = (0xC<<TM2C_CLK_SRC)
TM2C_CLK_PA4_FALL_gc = (0xD<<TM2C_CLK_SRC)
TM2C_OUT_SEL1 BIT 3
TM2C_OUT_SEL0 BIT 2
TM2C_OUT_SEL = TM2C_OUT_SEL0
TM2C_OUT_DISABLE_gc = (0<<TM2C_OUT_SEL)
TM2C_OUT_PB2_gc     = (1<<TM2C_OUT_SEL)
TM2C_OUT_PA3_gc     = (2<<TM2C_OUT_SEL)
TM2C_OUT_PB4_gc     = (3<<TM2C_OUT_SEL)
TM2C_MODE     BIT 1
TM2C_MODE_PERIOD_gc = (0<<TM2C_MODE)
TM2C_MODE_PWM_gc    = (1<<TM2C_MODE)
TM2C_INV_OUT  BIT 0

;TM2S register definitions
TM2S_PWM_RES   BIT 7
TM2S_PWM_8BIT_gc = (0<<TM2S_PWM_RES)
TM2S_PWM_6BIT_gc = (1<<TM2S_PWM_RES)
TM2S_PRESCALE1 BIT 6
TM2S_PRESCALE0 BIT 5
TM2S_PRESCALE = TM2S_PRESCALE0
TM2S_PRESCALE_DIV1_gc  = (0<<TM2S_PRESCALE)
TM2S_PRESCALE_DIV4_gc  = (1<<TM2S_PRESCALE)
TM2S_PRESCALE_DIV16_gc = (2<<TM2S_PRESCALE)
TM2S_PRESCALE_DIV64_gc = (3<<TM2S_PRESCALE)
TM2S_SCALE     BIT 0
TM2S_SCALE_bm = 0x1F

;TM3C register definitions
TM3C_CLK_SRC3 BIT 7
TM3C_CLK_SRC2 BIT 6
TM3C_CLK_SRC1 BIT 5
TM3C_CLK_SRC0 BIT 4
TM3C_CLK_SRC = TM3C_CLK_SRC0
TM3C_CLK_DISABLE_gc  = (0x0<<TM3C_CLK_SRC)
TM3C_CLK_SYSCLK_gc   = (0x1<<TM3C_CLK_SRC)
TM3C_CLK_IHRC_gc     = (0x2<<TM3C_CLK_SRC)
TM3C_CLK_EOSC_gc     = (0x3<<TM3C_CLK_SRC)
TM3C_CLK_ILRC_gc     = (0x4<<TM3C_CLK_SRC)
TM3C_CLK_COMP_gc     = (0x5<<TM3C_CLK_SRC)
TM3C_CLK_PA0_RISE_gc = (0x8<<TM3C_CLK_SRC)
TM3C_CLK_PA0_FALL_gc = (0x9<<TM3C_CLK_SRC)
TM3C_CLK_PB0_RISE_gc = (0xA<<TM3C_CLK_SRC)
TM3C_CLK_PB0_FALL_gc = (0xB<<TM3C_CLK_SRC)
TM3C_CLK_PA4_RISE_gc = (0xC<<TM3C_CLK_SRC)
TM3C_CLK_PA4_FALL_gc = (0xD<<TM3C_CLK_SRC)
TM3C_OUT_SEL1 BIT 3
TM3C_OUT_SEL0 BIT 2
TM3C_OUT_SEL = TM3C_OUT_SEL0
TM3C_OUT_DISABLE_gc = (0<<TM3C_OUT_SEL)
TM3C_OUT_PB5_gc     = (1<<TM3C_OUT_SEL)
TM3C_OUT_PB6_gc     = (2<<TM3C_OUT_SEL)
TM3C_OUT_PB7_gc     = (3<<TM3C_OUT_SEL)
TM3C_MODE     BIT 1
TM3C_MODE_PERIOD_gc = (0<<TM3C_MODE)
TM3C_MODE_PWM_gc    = (1<<TM3C_MODE)
TM3C_INV_OUT  BIT 0

;TM3S register definitions
TM3S_PWM_RES   BIT 7
TM3S_PWM_8BIT_gc = (0<<TM3S_PWM_RES)
TM3S_PWM_6BIT_gc = (1<<TM3S_PWM_RES)
TM3S_PRESCALE1 BIT 6
TM3S_PRESCALE0 BIT 5
TM3S_PRESCALE = TM3S_PRESCALE0
TM3S_PRESCALE_DIV1_gc  = (0<<TM3S_PRESCALE)
TM3S_PRESCALE_DIV4_gc  = (1<<TM3S_PRESCALE)
TM3S_PRESCALE_DIV16_gc = (2<<TM3S_PRESCALE)
TM3S_PRESCALE_DIV64_gc = (3<<TM3S_PRESCALE)
TM3S_SCALE     BIT 0
TM3S_SCALE_bm = 0x1F

;GPCC register definitions
GPCC_ENABLE     BIT 7
GPCC_RESULT     BIT 6
GPCC_TM2CLK     BIT 5
GPCC_INV_OUT    BIT 4
GPCC_MINUS_SEL2 BIT 3
GPCC_MINUS_SEL1 BIT 2
GPCC_MINUS_SEL0 BIT 1
GPCC_MINUS_SEL = GPCC_MINUS_SEL0
GPCC_MINUS_PA3_gc = (0<<GPCC_MINUS_SEL)
GPCC_MINUS_PA4_gc = (1<<GPCC_MINUS_SEL)
GPCC_MINUS_1V2_gc = (2<<GPCC_MINUS_SEL)
GPCC_MINUS_VIR_gc = (3<<GPCC_MINUS_SEL)
GPCC_MINUS_PB6_gc = (4<<GPCC_MINUS_SEL)
GPCC_MINUS_PB7_gc = (5<<GPCC_MINUS_SEL)
GPCC_PLUS_SEL   BIT 0
GPCC_PLUS_VIR_gc = (0<<GPCC_PLUS_SEL)
GPCC_PLUS_PA4_gc = (1<<GPCC_PLUS_SEL)

;GPCS register definitions
GPCS_OUT_EN     BIT 7
GPCS_RANGE_HIGH BIT 5
GPCS_RANGE_HIGH_8R_gc  = (0<<GPCS_RANGE_HIGH)
GPCS_RANGE_HIGH_16R_gc = (1<<GPCS_RANGE_HIGH)
GPCS_RANGE_LOW  BIT 4
GPCS_RANGE_LOW_8R_gc = (0<<GPCS_RANGE_LOW)
GPCS_RANGE_LOW_0R_gc = (1<<GPCS_RANGE_LOW)
GPCS_LEVEL      BIT 0
GPCS_LEVEL_bm = 0x0F

;PWMG0C register definitions
PWMG0_ENABLE  BIT 7
PWMG0_OUT     BIT 6
PWMG0_INV_OUT BIT 5
PWMG0_RESET   BIT 4
PWMG0_PIN2    BIT 3
PWMG0_PIN1    BIT 2
PWMG0_PIN0    BIT 1
PWMG0_PIN = PWMG0_PIN0
PWMG0_PIN_NONE_gc = (0<<PWMG0_PIN)
PWMG0_PIN_PB5_gc  = (1<<PWMG0_PIN)
PWMG0_PIN_PA0_gc  = (3<<PWMG0_PIN)
PWMG0_PIN_PB4_gc  = (4<<PWMG0_PIN)
PWMG0_CLK_SEL BIT 0
PWMG0_CLK_SYSCLK_gc = (0<<PWMG0_CLK_SEL)
PWMG0_CLK_IHRC_gc   = (1<<PWMG0_CLK_SEL)

;PWMG0S register definitions
PWMG0_INTMODE   BIT 7
PWMG0_INTMODE_MATCH_gc = (0<<PWMG0_INTMODE)
PWMG0_INTMODE_ZERO_gc  = (1<<PWMG0_INTMODE)
PWMG0_PRESCALE1 BIT 6
PWMG0_PRESCALE0 BIT 5
PWMG0_PRESCALE = PWMG0_PRESCALE0
PWMG0_PRESCALE_DIV1_gc  = (0<<PWMG0_PRESCALE)
PWMG0_PRESCALE_DIV4_gc  = (1<<PWMG0_PRESCALE)
PWMG0_PRESCALE_DIV16_gc = (2<<PWMG0_PRESCALE)
PWMG0_PRESCALE_DIV64_gc = (3<<PWMG0_PRESCALE)
PWMG0_SCALE     BIT 0
PWMG0_SCALE_bm = 0x1F

;PWMG1C register definitions
PWMG1_ENABLE  BIT 7
PWMG1_OUT     BIT 6
PWMG1_INV_OUT BIT 5
PWMG1_RESET   BIT 4
PWMG1_PIN2    BIT 3
PWMG1_PIN1    BIT 2
PWMG1_PIN0    BIT 1
PWMG1_PIN = PWMG1_PIN0
PWMG1_PIN_NONE_gc = (0<<PWMG1_PIN)
PWMG1_PIN_PB6_gc  = (1<<PWMG1_PIN)
PWMG1_PIN_PA4_gc  = (3<<PWMG1_PIN)
PWMG1_PIN_PB7_gc  = (4<<PWMG1_PIN)
PWMG1_CLK_SEL BIT 0
PWMG1_CLK_SYSCLK_gc = (0<<PWMG1_CLK_SEL)
PWMG1_CLK_IHRC_gc   = (1<<PWMG1_CLK_SEL)

;PWMG1S register definitions
PWMG1_INTMODE BIT 7
PWMG1_INTMODE_ZERO_gc  = (0<<PWMG1_INTMODE)
PWMG1_INTMODE_MATCH_gc = (1<<PWMG1_INTMODE)
PWMG1_PRESCALE1 BIT 6
PWMG1_PRESCALE0 BIT 5
PWMG1_PRESCALE = PWMG1_PRESCALE0
PWMG1_PRESCALE_DIV1_gc  = (0<<PWMG1_PRESCALE)
PWMG1_PRESCALE_DIV4_gc  = (1<<PWMG1_PRESCALE)
PWMG1_PRESCALE_DIV16_gc = (2<<PWMG1_PRESCALE)
PWMG1_PRESCALE_DIV64_gc = (3<<PWMG1_PRESCALE)
PWMG1_SCALE BIT 0
PWMG1_SCALE_bm = 0x1F

;PWMG2C register definitions
PWMG2_ENABLE BIT 7
PWMG2_OUT BIT 6
PWMG2_INV_OUT BIT 5
PWMG2_RESET BIT 4
PWMG2_PIN2 BIT 3
PWMG2_PIN1 BIT 2
PWMG2_PIN0 BIT 1
PWMG2_PIN = PWMG2_PIN0
PWMG2_PIN_NONE_gc = (0<<PWMG2_PIN)
PWMG2_PIN_PB3_gc  = (1<<PWMG2_PIN)
PWMG2_PIN_PA3_gc  = (3<<PWMG2_PIN)
PWMG2_PIN_PB2_gc  = (4<<PWMG2_PIN)
PWMG2_PIN_PA5_gc  = (5<<PWMG2_PIN)
PWMG2_CLK_SEL BIT 0
PWMG2_CLK_SYSCLK_gc = (0<<PWMG2_CLK_SEL)
PWMG2_CLK_IHRC_gc   = (1<<PWMG2_CLK_SEL)

;PWMG2S register definitions
PWMG2_INTMODE BIT 7
PWMG2_INTMODE_ZERO_gc  = (0<<PWMG2_INTMODE)
PWMG2_INTMODE_MATCH_gc = (1<<PWMG2_INTMODE)
PWMG2_PRESCALE1 BIT 6
PWMG2_PRESCALE0 BIT 5
PWMG2_PRESCALE = PWMG2_PRESCALE0
PWMG2_PRESCALE_DIV1_gc  = (0<<PWMG2_PRESCALE)
PWMG2_PRESCALE_DIV4_gc  = (1<<PWMG2_PRESCALE)
PWMG2_PRESCALE_DIV16_gc = (2<<PWMG2_PRESCALE)
PWMG2_PRESCALE_DIV64_gc = (3<<PWMG2_PRESCALE)
PWMG2_SCALE BIT 0
PWMG2_SCALE_bm = 0x1F

	RESTORE
