	SAVE
	LISTING OFF
	
;For use with asl <http://john.ccac.rwth-aachen.de:8000/as/>.

;Device constants
ICID = 0xA16
IHRC_FREQ = 16000000 ;16 MHz
ILRC_FREQ = 63000 ;63 kHz
INT_VECT = 0x010
PROGEND = 0x3EF
RAMEND = 0x3F

;Factory Calibration address locations
FACTORY_BGTR = 0x03f6
;TODO: something is stored at 0x3fc and 0x3ff

;FUSE definitions
FUSE_WORD = 0x03ff
FUSE_BITS_HIGH = 0x0260 ; - - - 0   B B 1 0   D 1 1 L   L L 0 S
;     Blank IC = 0x0FFD ; - - - 0   1 1 1 1   1 1 1 1   1 1 0 1
;                (Fast boot-up, 2.0V LVR, Normal IO drive, Security off)
FUSE_BOOTUP_SLOW = (0<<10)
FUSE_BOOTUP_FAST = (3<<10)
FUSE_IO_DRV_LOW    = (0<<7)
FUSE_IO_DRV_NORMAL = (1<<7)
FUSE_LVR_4V   = (0<<2)
FUSE_LVR_3V5  = (1<<2)
FUSE_LVR_3V   = (2<<2)
FUSE_LVR_2V75 = (3<<2)
FUSE_LVR_2V5  = (4<<2)
FUSE_LVR_1V8  = (5<<2)
FUSE_LVR_2V2  = (6<<2)
FUSE_LVR_2V   = (7<<2)
FUSE_SECURITY_ON  = (0<<0)
FUSE_SECURITY_OFF = (1<<0)

;Register address definitions
FLAG	SFR	0x00
		;0x01
SP	SFR	0x02
CLKMD	SFR	0x03
INTEN	SFR	0x04
INTRQ	SFR	0x05
T16M	SFR	0x06
		;0x07
		;0x08
TM2B	SFR	0x09
EOSCR	SFR	0x0a
IHRCR	SFR	0x0b
INTEGS	SFR	0x0c
PADIER	SFR	0x0d
		;0x0e
		;0x0f
PA	SFR	0x10
PAC	SFR	0x11
PAPH	SFR	0x12
		;0x13
		;0x14
		;0x15
		;0x16
TM2S	SFR	0x17
		;0x18
BGTR	SFR	0x19
GPCC	SFR	0x1a
MISC	SFR	0x1b
TM2C	SFR	0x1c
TM2CT	SFR	0x1d
GPCS	SFR	0x1e
ILRCR	SFR	0x1f

;FLAG register definitions
FLAG_OV BIT 3
FLAG_AC BIT 2
FLAG_C  BIT 1
FLAG_Z  BIT 0

;CLKMD register definitions
CLKMD_SYSCLK2 BIT 7
CLKMD_SYSCLK1 BIT 6
CLKMD_SYSCLK0 BIT 5
CLKMD_SYSCLK = CLKMD_SYSCLK0
CLKMD_IHRC_DIV4_gc  = (0<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV2_gc  = (1<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_ILRC_DIV4_gc  = (6<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_ILRC_gc       = (7<<CLKMD_SYSCLK | 0<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV16_gc = (0<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV8_gc  = (1<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_ILRC_DIV16_gc = (2<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV32_gc = (3<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_DIV64_gc = (4<<CLKMD_SYSCLK | 1<<CLKMD_CLOCKTYPE)
CLKMD_IHRC_EN BIT 4
CLKMD_CLOCKTYPE BIT 3
CLKMD_ILRC_EN BIT 2
CLKMD_WDT_EN BIT 1
CLKMD_PRSTB BIT 0

;INTEN register definitions
INTEN_TM2  BIT 6
INTEN_COMP BIT 4
INTEN_T16  BIT 2
INTEN_PA0  BIT 0

;INTRQ register definitions
INTRQ_TM2  BIT 6
INTRQ_COMP BIT 4
INTRQ_T16  BIT 2
INTRQ_PA0  BIT 0

;T16M register definitions
T16M_CLK_SRC2 BIT 7
T16M_CLK_SRC1 BIT 6
T16M_CLK_SRC0 BIT 5
T16M_CLK_SRC = T16M_CLK_SRC0
T16M_CLK_DISABLE_gc  = (0<<T16M_CLK_SRC)
T16M_CLK_SYSCLK_gc   = (1<<T16M_CLK_SRC)
T16M_CLK_PA4_FALL_gc = (3<<T16M_CLK_SRC)
T16M_CLK_IHRC_gc     = (4<<T16M_CLK_SRC)
T16M_CLK_ILRC_gc     = (6<<T16M_CLK_SRC)
T16M_CLK_PA0_FALL_gc = (7<<T16M_CLK_SRC)
T16M_CLK_DIV1 BIT 4
T16M_CLK_DIV0 BIT 3
T16M_CLK_DIV = T16M_CLK_DIV0
T16M_CLK_DIV1_gc  = (0<<T16M_CLK_DIV)
T16M_CLK_DIV4_gc  = (1<<T16M_CLK_DIV)
T16M_CLK_DIV16_gc = (2<<T16M_CLK_DIV)
T16M_CLK_DIV64_gc = (3<<T16M_CLK_DIV)
T16M_INT_SRC2 BIT 2
T16M_INT_SRC1 BIT 1
T16M_INT_SRC0 BIT 0
T16M_INT_SRC = T16M_INT_SRC0
T16M_INT_BIT8_gc  = (0<<T16M_INT_SRC)
T16M_INT_BIT9_gc  = (1<<T16M_INT_SRC)
T16M_INT_BIT10_gc = (2<<T16M_INT_SRC)
T16M_INT_BIT11_gc = (3<<T16M_INT_SRC)
T16M_INT_BIT12_gc = (4<<T16M_INT_SRC)
T16M_INT_BIT13_gc = (5<<T16M_INT_SRC)
T16M_INT_BIT14_gc = (6<<T16M_INT_SRC)
T16M_INT_BIT15_gc = (7<<T16M_INT_SRC)

;EOSCR register definitions
EOSCR_BG_LVR_SHUTDOWN BIT 0

;INTEGS register definitions
INTEGS_COMP BIT 6
INTEGS_COMP_BOTH_gc    = (0<<INTEGS_COMP)
INTEGS_COMP_RISING_gc  = (1<<INTEGS_COMP)
INTEGS_COMP_FALLING_gc = (2<<INTEGS_COMP)
INTEGS_T16 BIT 4
INTEGS_T16_RISING_gc   = (0<<INTEGS_T16)
INTEGS_T16_FALLING_gc  = (1<<INTEGS_T16)
INTEGS_PA0 BIT 0
INTEGS_PA0_BOTH_gc     = (0<<INTEGS_PA0)
INTEGS_PA0_RISING_gc   = (1<<INTEGS_PA0)
INTEGS_PA0_FALLING_gc  = (2<<INTEGS_PA0)

;MISC register definitions
MISC_WAKEUP BIT 5
MISC_WAKEUP_NORMAL_gc = (0<<MISC_WAKEUP)
MISC_WAKEUP_FAST_gc   = (1<<MISC_WAKEUP)
MISC_LVR_DISABLE BIT 2
MISC_WDT1 BIT 1
MISC_WDT0 BIT 0
MISC_WDT = MISC_WDT0
MISC_WDT_8K_gc   = (0<<MISC_WDT)
MISC_WDT_16K_gc  = (1<<MISC_WDT)
MISC_WDT_64K_gc  = (2<<MISC_WDT)
MISC_WDT_256K_gc = (3<<MISC_WDT)

;GPCC register definitions
GPCC_ENABLE BIT 7
GPCC_RESULT BIT 6
GPCC_TM2CLK BIT 5
GPCC_INV_OUT BIT 4
GPCC_MINUS_SEL2 BIT 3
GPCC_MINUS_SEL1 BIT 2
GPCC_MINUS_SEL0 BIT 1
GPCC_MINUS_SEL = GPCC_MINUS_SEL0
GPCC_MINUS_PA3_gc = (0<<GPCC_MINUS_SEL)
GPCC_MINUS_PA4_gc = (1<<GPCC_MINUS_SEL)
GPCC_MINUS_1V2_gc = (2<<GPCC_MINUS_SEL)
GPCC_MINUS_VIR_gc = (3<<GPCC_MINUS_SEL)
GPCC_MINUS_PA6_gc = (4<<GPCC_MINUS_SEL)
GPCC_MINUS_PA7_gc = (5<<GPCC_MINUS_SEL)
GPCC_PLUS_SEL BIT 0
GPCC_PLUS_VIR_gc = (0<<GPCC_PLUS_SEL)
GPCC_PLUS_PA4_gc = (1<<GPCC_PLUS_SEL)

;GPCS register definitions
GPCS_OUT_EN BIT 7
GPCS_WAKEUP BIT 6
GPCS_RANGE_HIGH BIT 5
GPCS_RANGE_HIGH_8R_bm  = (0<<GPCS_RANGE_HIGH)
GPCS_RANGE_HIGH_16R_bm = (1<<GPCS_RANGE_HIGH)
GPCS_RANGE_LOW BIT 4
GPCS_RANGE_LOW_8R_bm = (0<<GPCS_RANGE_LOW)
GPCS_RANGE_LOW_0R_bm = (1<<GPCS_RANGE_LOW)
GPCS_LEVEL BIT 0
GPCS_LEVEL_bm = 0x0F

;TM2C register definitions
TM2C_CLK_SRC3 BIT 7
TM2C_CLK_SRC2 BIT 6
TM2C_CLK_SRC1 BIT 5
TM2C_CLK_SRC0 BIT 4
TM2C_CLK_SRC = TM2C_CLK_SRC0
TM2C_CLK_DISABLE_gc  = (0x0<<TM2C_CLK_SRC)
TM2C_CLK_SYSCLK_gc   = (0x1<<TM2C_CLK_SRC)
TM2C_CLK_IHRC_gc     = (0x2<<TM2C_CLK_SRC)
TM2C_CLK_ILRC_gc     = (0x4<<TM2C_CLK_SRC)
TM2C_CLK_COMP_gc     = (0x5<<TM2C_CLK_SRC)
TM2C_CLK_PA0_RISE_gc = (0x8<<TM2C_CLK_SRC)
TM2C_CLK_PA0_FALL_gc = (0x9<<TM2C_CLK_SRC)
TM2C_CLK_PA4_RISE_gc = (0xC<<TM2C_CLK_SRC)
TM2C_CLK_PA4_FALL_gc = (0xD<<TM2C_CLK_SRC)
TM2C_OUT_SEL1 BIT 3
TM2C_OUT_SEL0 BIT 2
TM2C_OUT_SEL = TM2C_OUT_SEL0
TM2C_OUT_DISABLE_gc = (0<<TM2C_OUT_SEL)
TM2C_OUT_PA3_gc     = (2<<TM2C_OUT_SEL)
TM2C_OUT_PA4_gc     = (3<<TM2C_OUT_SEL)
TM2C_MODE BIT 1
TM2C_MODE_PERIOD_gc = (0<<TM2C_MODE)
TM2C_MODE_PWM_gc    = (1<<TM2C_MODE)
TM2C_INV_OUT BIT 0

;TM2S register definitions
TM2S_PWM_RES BIT 7
TM2S_PWM_8BIT_gc = (0<<TM2S_PWM_RES)
TM2S_PWM_6BIT_gc = (1<<TM2S_PWM_RES)
TM2S_PRESCALE1 BIT 6
TM2S_PRESCALE0 BIT 5
TM2S_PRESCALE = TM2S_PRESCALE0
TM2S_PRESCALE_DIV1_gc  = (0<<TM2S_PRESCALE)
TM2S_PRESCALE_DIV4_gc  = (1<<TM2S_PRESCALE)
TM2S_PRESCALE_DIV16_gc = (2<<TM2S_PRESCALE)
TM2S_PRESCALE_DIV64_gc = (3<<TM2S_PRESCALE)
TM2S_SCALE BIT 0
TM2S_SCALE_bm = 0x1F

	RESTORE
